import * as squint_core from 'squint-cljs/core.js';
import * as commands from '@codemirror/commands';
import * as u from './util.mjs';
import * as sel from './selections.mjs';
import * as n from './node.mjs';
import * as format from './extensions/formatting.mjs';
import * as sel_history from './extensions/selection_history.mjs';
var view_command = function (f) {
return function ({state,dispatch}) {
const G__1151 = f(state);
if ((G__1151 == null)) {
} else {
dispatch(G__1151)};
return true;
};
};
var scoped_view_command = function (f) {
return function ({state,dispatch}) {
if (squint_core.truth_(n.within_program_QMARK_(state))) {
const G__1161 = f(state);
if ((G__1161 == null)) {
} else {
dispatch(G__1161)};
return true;} else {
return false;}
};
};
var unwrap_STAR_ = function (state) {
return u.update_ranges(state, (function (p__117) {
const map__12 = p__117;
const range3 = map__12;
const from4 = squint_core.get(map__12, "from");
const to5 = squint_core.get(map__12, "to");
const empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
const temp__23976__auto__7 = (() => {
const G__1188 = n.tree(state, from4, -1);
const G__1189 = ((G__1188 == null)) ? (null) : (n.closest(G__1188, n.coll_QMARK_));
if ((G__1189 == null)) {
return null;} else {
return u.guard(G__1189, n.balanced_QMARK_);}
})();
if (squint_core.truth_(temp__23976__auto__7)) {
const nearest_balanced_coll10 = temp__23976__auto__7;
return ({ "cursor": (from4 - 1), "changes": [n.from_to(n.down(nearest_balanced_coll10)), n.from_to(n.down_last(nearest_balanced_coll10))] });}}
}));
};
var copy_to_clipboard_BANG_ = function (text) {
const focus_el1 = squint_core.get(document, "activeElement");
const input_el2 = document.createElement("textarea");
input_el2.setAttribute("class", "clipboard-input");
squint_core.assoc_BANG_(input_el2, "innerHTML", text);
document.body.appendChild(input_el2);
input_el2.focus(({ "preventScroll": true }));
input_el2.select();
document.execCommand("copy");
focus_el1.focus(({ "preventScroll": true }));
return document.body.removeChild(input_el2);
};
var kill_STAR_ = function (state) {
return u.update_ranges(state, (function (p__119) {
const map__12 = p__119;
const range3 = map__12;
const from4 = squint_core.get(map__12, "from");
const to5 = squint_core.get(map__12, "to");
const empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
const node7 = n.tree(state, from4);
const parent8 = n.closest(node7, (function (_PERCENT_1) {
const or__24281__auto__9 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__24281__auto__9)) {
return or__24281__auto__9;} else {
const or__24281__auto__10 = n.string_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__24281__auto__10)) {
return or__24281__auto__10;} else {
return n.top_QMARK_(_PERCENT_1);}}
}));
const line_end11 = state.doc.lineAt(from4).to;
const next_children12 = (squint_core.truth_(parent8)) ? (n.children(parent8, from4, 1)) : (null);
const last_child_on_line13 = (squint_core.truth_(parent8)) ? ((() => {
const G__12014 = next_children12;
const G__12015 = ((G__12014 == null)) ? (null) : (squint_core.take_while(squint_core.every_pred((function (_PERCENT_1) {
return (n.start(_PERCENT_1)) <= (line_end11);
})), G__12014));
if ((G__12015 == null)) {
return null;} else {
return squint_core.last(G__12015);}
})()) : (null);
const to16 = (squint_core.truth_(n.string_QMARK_(parent8))) ? ((() => {
const content17 = squint_core.str(n.string(state, parent8));
const content_from18 = squint_core.subs(content17, (from4) - (n.start(parent8)));
const next_newline19 = content_from18.indexOf("\n");
if ((next_newline19 < 0)) {
return (n.end(parent8) - 1);} else {
return (from4) + (next_newline19) + (1);}
})()) : ((squint_core.truth_(last_child_on_line13)) ? ((squint_core.truth_(n.end_edge_QMARK_(last_child_on_line13))) ? (n.start(last_child_on_line13)) : (n.end(last_child_on_line13))) : ((squint_core.truth_((() => {
const G__12120 = squint_core.first(next_children12);
const G__12121 = ((G__12120 == null)) ? (null) : (n.start(G__12120));
if ((G__12121 == null)) {
return null;} else {
return (G__12121) > (line_end11);}
})())) ? (n.start(squint_core.first(next_children12))) : (null)));
if (squint_core.truth_(u.node_js_QMARK_)) {
} else {
copy_to_clipboard_BANG_(n.string(state, from4, to16))};
if (squint_core.truth_(to16)) {
return ({ "cursor": from4, "changes": ({ "from": from4, "to": to16 }) });}} else {
copy_to_clipboard_BANG_(n.string(state, from4, to5));
return ({ "cursor": from4, "changes": u.from_to(from4, to5) });}
}));
};
var enter_and_indent_STAR_ = function (state) {
const ctx1 = format.make_indent_context(state);
return u.update_ranges(state, (function (p__122) {
const map__23 = p__122;
const range4 = map__23;
const from5 = squint_core.get(map__23, "from");
const to6 = squint_core.get(map__23, "to");
const empty7 = squint_core.get(map__23, "empty");
const indent_at8 = (() => {
const G__1239 = n.closest(n.tree(state, from5), squint_core.some_fn(n.coll_QMARK_, n.top_QMARK_));
const G__12310 = ((G__1239 == null)) ? (null) : (n.inner_span(G__1239));
if ((G__12310 == null)) {
return null;} else {
return n.start(G__12310);}
})();
const indent11 = (squint_core.truth_(indent_at8)) ? (format.get_indentation(ctx1, indent_at8)) : (null);
const insertion12 = squint_core.str("\n", (squint_core.truth_(indent11)) ? (format.spaces(state, indent11)) : (null));
return ({ "cursor": (from5) + (squint_core.count(insertion12)), "changes": [({ "from": from5, "to": to6, "insert": insertion12 })] });
}));
};
var nav_position = function (state, from, dir) {
const or__24281__auto__1 = (() => {
const G__1242 = n.closest(n.tree(state, from), (function (_PERCENT_1) {
const or__24281__auto__3 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__24281__auto__3)) {
return or__24281__auto__3;} else {
const or__24281__auto__4 = n.string_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__24281__auto__4)) {
return or__24281__auto__4;} else {
return n.top_QMARK_(_PERCENT_1);}}
}));
const G__1245 = ((G__1242 == null)) ? (null) : (n.children(G__1242, from, dir));
const G__1246 = ((G__1245 == null)) ? (null) : (squint_core.first(G__1245));
if ((G__1246 == null)) {
return null;} else {
return squint_core.get(G__1246, (() => {
const G__1257 = dir;
switch (G__1257) {case -1:
return "from";
break;
case 1:
return "to";
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1257))}
})());}
})();
if (squint_core.truth_(or__24281__auto__1)) {
return or__24281__auto__1;} else {
return sel.constrain(state, (from) + (dir));}
};
var nav = function (dir) {
return function (state) {
return u.update_ranges(state, (function ({from,to,empty}) {
if (squint_core.truth_(empty)) {
return ({ "cursor": nav_position(state, from, dir) });} else {
return ({ "cursor": squint_core.get(u.from_to(from, to), (() => {
const G__1261 = dir;
switch (G__1261) {case -1:
return "from";
break;
case 1:
return "to";
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1261))}
})()) });}
}));
};
};
var nav_select = function (dir) {
return function (state) {
return u.update_ranges(state, (function ({from,to,empty}) {
if (squint_core.truth_(empty)) {
return ({ "range": n.balanced_range(state, from, nav_position(state, from, dir)) });} else {
return ({ "range": (() => {
const map__12 = u.from_to(from, to);
const from3 = squint_core.get(map__12, "from");
const to4 = squint_core.get(map__12, "to");
const G__1275 = dir;
switch (G__1275) {case 1:
return n.balanced_range(state, from3, nav_position(state, to4, dir));
break;
case -1:
return n.balanced_range(state, nav_position(state, from3, dir), to4);
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1275))}
})() });}
}));
};
};
var balance_ranges = function (state) {
return u.update_ranges(state, (function ({from,to,empty}) {
if (squint_core.truth_(empty)) {
return null;} else {
return ({ "range": n.balanced_range(state, from, to) });}
}));
};
var slurp = function (direction) {
return function (state) {
return u.update_ranges(state, (function ({from,empty}) {
if (squint_core.truth_(empty)) {
const temp__23976__auto__1 = n.closest(n.tree(state, from), squint_core.every_pred(squint_core.some_fn(n.coll_QMARK_, n.string_QMARK_), (function (_PERCENT_1) {
return squint_core.not((() => {
const G__1282 = direction;
switch (G__1282) {case 1:
const G__1294 = _PERCENT_1;
const G__1295 = ((G__1294 == null)) ? (null) : (n.with_prefix(G__1294));
const G__1296 = ((G__1295 == null)) ? (null) : (n.right(G__1295));
if ((G__1296 == null)) {
return null;} else {
return n.end_edge_QMARK_(G__1296);}
break;
case -1:
const G__1307 = _PERCENT_1;
const G__1308 = ((G__1307 == null)) ? (null) : (n.with_prefix(G__1307));
const G__1309 = ((G__1308 == null)) ? (null) : (n.left(G__1308));
if ((G__1309 == null)) {
return null;} else {
return n.start_edge_QMARK_(G__1309);}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1282))}
})());
})));
if (squint_core.truth_(temp__23976__auto__1)) {
const parent10 = temp__23976__auto__1;
const str_QMARK_11 = n.string_QMARK_(parent10);
const temp__23976__auto__12 = (() => {
const G__13113 = direction;
switch (G__13113) {case 1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.rights(n.with_prefix(parent10))));
break;
case -1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.lefts(n.with_prefix(parent10))));
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__13113))}
})();
if (squint_core.truth_(temp__23976__auto__12)) {
const target15 = temp__23976__auto__12;
return ({ "cursor/mapped": from, "changes": (() => {
const G__13216 = direction;
switch (G__13216) {case 1:
const edge18 = n.down_last(parent10);
return [({ "from": n.end(target15), "insert": n.name(edge18) }), (() => {
const G__13319 = n.from_to(edge18);
if (squint_core.not(str_QMARK_11)) {
return squint_core.assoc_BANG_(G__13319, "insert", " ");} else {
return G__13319;}
})()];
break;
case -1:
const edge20 = n.left_edge_with_prefix(state, parent10);
const start21 = n.start(n.with_prefix(parent10));
return [(() => {
const G__13422 = ({ "from": start21, "to": (start21) + (squint_core.count(edge20)) });
if (squint_core.not(str_QMARK_11)) {
return squint_core.assoc_BANG_(G__13422, "insert", " ");} else {
return G__13422;}
})(), ({ "from": n.start(target15), "insert": edge20 })];
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__13216))}
})() });}}}
}));
};
};
var barf = function (direction) {
return function (state) {
return u.update_ranges(state, (function ({from,empty}) {
if (squint_core.truth_(empty)) {
const temp__23976__auto__1 = n.closest(n.tree(state, from), n.coll_QMARK_);
if (squint_core.truth_(temp__23976__auto__1)) {
const parent2 = temp__23976__auto__1;
const G__1353 = direction;
switch (G__1353) {case 1:
const temp__23976__auto__5 = (() => {
const G__1366 = n.down_last(parent2);
const G__1367 = ((G__1366 == null)) ? (null) : (n.lefts(G__1366));
const G__1368 = ((G__1367 == null)) ? (null) : (squint_core.remove(n.line_comment_QMARK_, G__1367));
const G__1369 = ((G__1368 == null)) ? (null) : (squint_core.drop(1, G__1368));
if ((G__1369 == null)) {
return null;} else {
return squint_core.first(G__1369);}
})();
if (squint_core.truth_(temp__23976__auto__5)) {
const target10 = temp__23976__auto__5;
return ({ "cursor": squint_core.min(n.end(target10), from), "changes": [({ "from": n.end(target10), "insert": n.name(n.down_last(parent2)) }), squint_core.assoc_BANG_(n.from_to(n.down_last(parent2)), "insert", " ")] });}
break;
case -1:
const temp__23976__auto__11 = (() => {
const G__13712 = n.down(parent2);
const G__13713 = ((G__13712 == null)) ? (null) : (n.rights(G__13712));
const G__13714 = ((G__13713 == null)) ? (null) : (squint_core.remove(n.line_comment_QMARK_, G__13713));
const G__13715 = ((G__13714 == null)) ? (null) : (squint_core.drop(1, G__13714));
if ((G__13715 == null)) {
return null;} else {
return squint_core.first(G__13715);}
})();
if (squint_core.truth_(temp__23976__auto__11)) {
const next_first_child16 = temp__23976__auto__11;
const left_edge17 = n.left_edge_with_prefix(state, parent2);
const left_start18 = n.start(n.with_prefix(parent2));
return ({ "cursor": squint_core.max(from, (n.start(next_first_child16)) + ((squint_core.count(left_edge17) + 1))), "changes": [({ "from": n.start(next_first_child16), "insert": squint_core.str(" ", left_edge17) }), ({ "from": left_start18, "to": (left_start18) + (squint_core.count(left_edge17)), "insert": format.spaces(state, squint_core.count(left_edge17)) })] });}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1353))}}}
}));
};
};
var builtin_index = ({ "cursorLineStart": commands.cursorLineStart, "cursorLineDown": commands.cursorLineDown, "selectAll": commands.selectAll, "selectLineUp": commands.selectLineUp, "cursorLineBoundaryForward": commands.cursorLineBoundaryForward, "selectLineBoundaryBackward": commands.selectLineBoundaryBackward, "deleteCharBackward": commands.deleteCharBackward, "insertNewlineAndIndent": commands.insertNewlineAndIndent, "cursorLineBoundaryBackward": commands.cursorLineBoundaryBackward, "selectCharRight": commands.selectCharRight, "selectPageUp": commands.selectPageUp, "deleteCharForward": commands.deleteCharForward, "cursorCharLeft": commands.cursorCharLeft, "cursorGroupBackward": commands.cursorGroupBackward, "selectDocStart": commands.selectDocStart, "selectGroupBackward": commands.selectGroupBackward, "cursorDocEnd": commands.cursorDocEnd, "deleteGroupBackward": commands.deleteGroupBackward, "selectLineStart": commands.selectLineStart, "deleteGroupForward": commands.deleteGroupForward, "selectDocEnd": commands.selectDocEnd, "selectPageDown": commands.selectPageDown, "cursorPageDown": commands.cursorPageDown, "cursorPageUp": commands.cursorPageUp, "selectLineBoundaryForward": commands.selectLineBoundaryForward, "cursorLineEnd": commands.cursorLineEnd, "cursorGroupForward": commands.cursorGroupForward, "cursorCharRight": commands.cursorCharRight, "selectGroupForward": commands.selectGroupForward, "selectLineEnd": commands.selectLineEnd, "selectCharLeft": commands.selectCharLeft, "splitLine": commands.splitLine, "selectLineDown": commands.selectLineDown, "transposeChars": commands.transposeChars, "cursorLineUp": commands.cursorLineUp, "cursorDocStart": commands.cursorDocStart });
var indent = view_command(format.format);
var unwrap = view_command(unwrap_STAR_);
var kill = scoped_view_command(kill_STAR_);
var nav_right = view_command(nav(1));
var nav_left = view_command(nav(-1));
var nav_select_right = view_command(nav_select(1));
var nav_select_left = view_command(nav_select(-1));
var slurp_forward = view_command(slurp(1));
var slurp_backward = view_command(slurp(-1));
var barf_forward = view_command(barf(1));
var barf_backward = view_command(barf(-1));
var selection_grow = view_command(sel_history.selection_grow_STAR_);
var selection_return = view_command(sel_history.selection_return_STAR_);
var enter_and_indent = view_command(enter_and_indent_STAR_);
var paredit_index = ({ "indent": indent, "nav-left": nav_left, "enter-and-indent": enter_and_indent, "selection-grow": selection_grow, "kill": kill, "slurp-forward": slurp_forward, "nav-select-right": nav_select_right, "nav-select-left": nav_select_left, "barf-forward": barf_forward, "barf-backward": barf_backward, "nav-right": nav_right, "slurp-backward": slurp_backward, "unwrap": unwrap, "selection-return": selection_return });
var index = squint_core.merge(builtin_index, paredit_index);
var reverse_index = squint_core.reduce_kv((function (_PERCENT_1, _PERCENT_2, _PERCENT_3) {
return squint_core.assoc(_PERCENT_1, _PERCENT_3, _PERCENT_2);
}), ({  }), index);

export { nav_select_left, index, view_command, barf_backward, scoped_view_command, kill_STAR_, enter_and_indent_STAR_, unwrap, enter_and_indent, nav_select, slurp, nav_position, indent, nav_select_right, slurp_forward, selection_grow, nav, balance_ranges, nav_left, copy_to_clipboard_BANG_, barf, builtin_index, barf_forward, paredit_index, kill, reverse_index, unwrap_STAR_, nav_right, slurp_backward, selection_return }
