import * as squint_core from 'squint-cljs/core.js';
import { EditorState, Prec } from '@codemirror/state';
import * as view from '@codemirror/view';
import * as str from 'squint-cljs/src/squint/string.js';
import * as n from './../node.mjs';
import * as u from './../util.mjs';
import { from_to } from './../util.mjs';
var in_string_QMARK_ = function (state, pos) {
return squint_core.contains_QMARK_(new Set(["StringContent", "String"]), n.name(n.tree(state, pos)));
};
var escaped_QMARK_ = function (state, pos) {
return ("\\") === (state.doc.slice(squint_core.max(0, (pos - 1)), pos).toString());
};
var backspace_backoff = function (state, from, to) {
if (squint_core.truth_((() => {
const and__24299__auto__1 = (() => {
const G__1422 = n.node_BAR_(state, (from - 1));
if ((G__1422 == null)) {
return null;} else {
return u.guard(G__1422, n.line_comment_QMARK_);}
})();
if (squint_core.truth_(and__24299__auto__1)) {
return squint_core.not((() => {
const or__24281__auto__3 = str.blank_QMARK_(u.line_content_at(state, from));
if (squint_core.truth_(or__24281__auto__3)) {
return or__24281__auto__3;} else {
const G__1434 = n._BAR_node(state, from);
if ((G__1434 == null)) {
return null;} else {
return u.guard(G__1434, n.line_comment_QMARK_);}}
})());} else {
return and__24299__auto__1;}
})())) {
return ({ "cursor": (from - 1) });} else {
return u.deletion(from, to);}
};
var handle_backspace = function (p__144) {
const map__12 = p__144;
const state3 = map__12;
if (squint_core.truth_((() => {
const and__24299__auto__4 = (1) === (state3.selection.ranges.length);
if (and__24299__auto__4) {
const range5 = squint_core.get_in(state3, ["selection", "ranges", 0]);
const and__24299__auto__6 = range5.empty;
if (squint_core.truth_(and__24299__auto__6)) {
return (0) === (range5.from);} else {
return and__24299__auto__6;}} else {
return and__24299__auto__4;}
})())) {
return null;} else {
return u.update_ranges(state3, ({ "annotations": u.user_event_annotation("delete") }), (function (p__145) {
const map__78 = p__145;
const _range9 = map__78;
const head10 = squint_core.get(map__78, "head");
const empty11 = squint_core.get(map__78, "empty");
const anchor12 = squint_core.get(map__78, "anchor");
const map__1314 = from_to(head10, anchor12);
const _range15 = map__1314;
const from16 = squint_core.get(map__1314, "from");
const to17 = squint_core.get(map__1314, "to");
const node_BAR_18 = n.tree(state3).resolveInner(from16, -1);
const parent19 = node_BAR_18.parent;
if (squint_core.truth_((() => {
const or__24281__auto__20 = squint_core.not(empty11);
if (or__24281__auto__20) {
return or__24281__auto__20;} else {
const or__24281__auto__21 = ("StringContent") === (n.name(n.tree(state3, from16, -1)));
if (or__24281__auto__21) {
return or__24281__auto__21;} else {
const and__24299__auto__22 = parent19;
if (squint_core.truth_(and__24299__auto__22)) {
const and__24299__auto__23 = squint_core.not(n.balanced_QMARK_(parent19));
if (and__24299__auto__23) {
return n.left_edge_QMARK_(node_BAR_18);} else {
return and__24299__auto__23;}} else {
return and__24299__auto__22;}}}
})())) {
return u.deletion(from16, to17);} else {
if (squint_core.truth_((() => {
const and__24299__auto__24 = n.right_edge_QMARK_(node_BAR_18);
if (squint_core.truth_(and__24299__auto__24)) {
return (from16) == (n.end(parent19));} else {
return and__24299__auto__24;}
})())) {
return ({ "cursor": (from16 - 1) });} else {
if (squint_core.truth_((() => {
const and__24299__auto__25 = (() => {
const or__24281__auto__26 = n.start_edge_QMARK_(node_BAR_18);
if (squint_core.truth_(or__24281__auto__26)) {
return or__24281__auto__26;} else {
return n.same_edge_QMARK_(node_BAR_18);}
})();
if (squint_core.truth_(and__24299__auto__25)) {
return (n.start(node_BAR_18)) == (n.start(parent19));} else {
return and__24299__auto__25;}
})())) {
if (squint_core.truth_(n.empty_QMARK_(n.up(node_BAR_18)))) {
return ({ "cursor": n.start(parent19), "changes": [from_to(n.start(parent19), n.end(parent19))] });} else {
return ({ "cursor": from16 });}} else {
if ("else") {
return backspace_backoff(state3, from16, to17);} else {
return null;}}}}
}));}
};
var coll_pairs = (function (x) {
return squint_core.get(({ "(": ")", "[": "]", "{": "}", "\"": "\"" }), x);
});
var handle_open = function (state, open) {
const close1 = coll_pairs(open);
return u.update_ranges(state, ({ "annotations": u.user_event_annotation("input") }), (function ({from,to,head,anchor,empty}) {
if (squint_core.truth_(in_string_QMARK_(state, from))) {
if (("\"") === (open)) {
return u.insertion(head, "\\\"");} else {
return u.insertion(from, to, open);}} else {
if (squint_core.truth_(escaped_QMARK_(state, from))) {
return u.insertion(from, to, open);} else {
if ("else") {
if (squint_core.truth_(empty)) {
return ({ "changes": ({ "insert": squint_core.str(open, close1), "from": head }), "cursor": (head) + (squint_core.count(open)) });} else {
return ({ "changes": [({ "insert": open, "from": from }), ({ "insert": close1, "from": to })], "from-to": [(anchor) + (squint_core.count(open)), (head) + (squint_core.count(open))] });}} else {
return null;}}}
}));
};
var handle_close = function (state, key_name) {
return u.update_ranges(state, ({ "annotations": u.user_event_annotation("input") }), (function (p__146) {
const map__12 = p__146;
const _range3 = map__12;
const empty4 = squint_core.get(map__12, "empty");
const head5 = squint_core.get(map__12, "head");
const from6 = squint_core.get(map__12, "from");
const to7 = squint_core.get(map__12, "to");
if (squint_core.truth_((() => {
const or__24281__auto__8 = in_string_QMARK_(state, from6);
if (squint_core.truth_(or__24281__auto__8)) {
return or__24281__auto__8;} else {
return escaped_QMARK_(state, from6);}
})())) {
return u.insertion(from6, to7, key_name);} else {
if (squint_core.truth_(empty4)) {
const or__24281__auto__9 = (() => {
const unbalanced10 = (() => {
const G__14711 = n.tree(state, head5, -1);
const G__14712 = ((G__14711 == null)) ? (null) : (n.ancestors(G__14711));
const G__14713 = ((G__14712 == null)) ? (null) : (squint_core.filter(squint_core.every_pred(n.coll_QMARK_, squint_core.complement(n.balanced_QMARK_)), G__14712));
if ((G__14713 == null)) {
return null;} else {
return squint_core.first(G__14713);}
})();
const closing14 = (() => {
const G__14815 = unbalanced10;
const G__14816 = ((G__14815 == null)) ? (null) : (n.down(G__14815));
if ((G__14816 == null)) {
return null;} else {
return n.closed_by(G__14816);}
})();
const pos17 = (() => {
const G__14918 = unbalanced10;
if ((G__14918 == null)) {
return null;} else {
return n.end(G__14918);}
})();
if (squint_core.truth_((() => {
const and__24299__auto__19 = closing14;
if (squint_core.truth_(and__24299__auto__19)) {
return (closing14) === (key_name);} else {
return and__24299__auto__19;}
})())) {
return ({ "changes": ({ "from": pos17, "insert": closing14 }), "cursor": (pos17 + 1) });}
})();
if (squint_core.truth_(or__24281__auto__9)) {
return or__24281__auto__9;} else {
const or__24281__auto__20 = (() => {
const temp__23976__auto__21 = (() => {
const temp__23976__auto__22 = n.terminal_cursor(n.tree(state), head5, 1);
if (squint_core.truth_(temp__23976__auto__22)) {
const cursor23 = temp__23976__auto__22;
while(true){
if (squint_core.truth_(n.right_edge_type_QMARK_(cursor23.type))) {
return n.end(cursor23);} else {
if (squint_core.truth_(cursor23.next())) {
continue;
}};break;
}
}
})();
if (squint_core.truth_(temp__23976__auto__21)) {
const close_node_end24 = temp__23976__auto__21;
return ({ "cursor": close_node_end24 });}
})();
if (squint_core.truth_(or__24281__auto__20)) {
return or__24281__auto__20;} else {
return ({ "cursor": head5 });}}}}
}));
};
var handle_backspace_cmd = function (p__150) {
const map__12 = p__150;
const view3 = map__12;
const state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_backspace(state4));
};
var handle_open_cmd = function (key_name) {
return function (p__151) {
const map__12 = p__151;
const view3 = map__12;
const state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_open(state4, key_name));
};
};
var handle_close_cmd = function (key_name) {
return function (p__152) {
const map__12 = p__152;
const view3 = map__12;
const state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_close(state4, key_name));
};
};
var guard_scope = function (cmd) {
return function (p__153) {
const map__12 = p__153;
const view3 = map__12;
const state4 = squint_core.get(map__12, "state");
if (squint_core.truth_((() => {
const or__24281__auto__5 = n.embedded_QMARK_(state4);
if (squint_core.truth_(or__24281__auto__5)) {
return or__24281__auto__5;} else {
return n.within_program_QMARK_(state4);}
})())) {
return cmd(view3);} else {
return false;}
};
};
var extension = function () {
return Prec.high(view.keymap.of([({ "key": "Backspace", "run": guard_scope((function (p__154) {
const map__12 = p__154;
const view3 = map__12;
const state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_backspace(state4));
})) }), ({ "key": "(", "run": guard_scope(handle_open_cmd("(")) }), ({ "key": "[", "run": guard_scope(handle_open_cmd("[")) }), ({ "key": "{", "run": guard_scope(handle_open_cmd("{")) }), ({ "key": "\"", "run": guard_scope(handle_open_cmd("\"")) }), ({ "key": ")", "run": guard_scope(handle_close_cmd(")")) }), ({ "key": "]", "run": guard_scope(handle_close_cmd("]")) }), ({ "key": "}", "run": guard_scope(handle_close_cmd("}")) })]));
};

export { handle_backspace_cmd, handle_backspace, handle_close_cmd, backspace_backoff, escaped_QMARK_, guard_scope, handle_close, handle_open_cmd, extension, in_string_QMARK_, handle_open, coll_pairs }
