import * as squint_core from 'squint-cljs/core.js';
import * as state from '@codemirror/state';
import { StateEffect, StateField } from '@codemirror/state';
import * as view from '@codemirror/view';
import { EditorView, Decoration, keymap } from '@codemirror/view';
import { keyName } from 'w3c-keyname';
import * as u from './../util.mjs';
import * as n from './../node.mjs';
import * as str from 'squint-cljs/src/squint/string.js';
var uppermost_edge_here = function (pos, node) {
const node1 = (() => {
const or__24281__auto__2 = squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.complement(n.top_QMARK_), (function (_PERCENT_1) {
const or__24281__auto__3 = ((pos) === (n.end(_PERCENT_1))) && ((n.end(_PERCENT_1)) === (n.end(node)));
if (squint_core.truth_(or__24281__auto__3)) {
return or__24281__auto__3;} else {
return ((pos) === (n.start(_PERCENT_1))) && ((n.start(_PERCENT_1)) === (n.start(node)));}
})), squint_core.iterate(n.up, node)));
if (squint_core.truth_(or__24281__auto__2)) {
return or__24281__auto__2;} else {
return node;}
})();
if (("Discard") === (n.name(node1))) {
return squint_core.last(n.children(node1));} else {
return node1;}
};
var main_selection = function (state) {
return squint_core.get_in((() => {
const parent__39__auto__1 = squint_core.get_in(state, ["selection"]);
const f__40__auto__2 = squint_core.get(parent__39__auto__1, "asSingle");
return f__40__auto__2.call(parent__39__auto__1);
})(), ["ranges", 0]);
};
var node_at_cursor = (() => {
const f159 = (function (var_args) {
const G__1621 = arguments.length;
switch (G__1621) {case 1:
return f159.cljs$core$IFn$_invoke$arity$1((arguments[0]));
break;
case 2:
return f159.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f159.cljs$core$IFn$_invoke$arity$1 = (function (state) {
return node_at_cursor(state, squint_core.get(main_selection(state), "from"));
});
f159.cljs$core$IFn$_invoke$arity$2 = (function (state, from) {
const G__1633 = n.nearest_touching(state, from, -1);
const G__1634 = ((G__1633 == null)) ? (null) : ((function (_PERCENT_1) {
if (squint_core.truth_((() => {
const or__24281__auto__5 = n.terminal_type_QMARK_(n.type(_PERCENT_1));
if (squint_core.truth_(or__24281__auto__5)) {
return or__24281__auto__5;} else {
const or__24281__auto__6 = (n.start(_PERCENT_1)) <= (from);
if (or__24281__auto__6) {
return or__24281__auto__6;} else {
return (n.end(_PERCENT_1)) <= (from);}}
})())) {
const G__1647 = _PERCENT_1;
if (squint_core.truth_((() => {
const or__24281__auto__8 = n.top_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__24281__auto__8)) {
return or__24281__auto__8;} else {
const and__24299__auto__9 = squint_core.not(n.terminal_type_QMARK_(n.type(_PERCENT_1)));
if (and__24299__auto__9) {
return ((n.start(_PERCENT_1)) < (from)) && ((from) < (n.end(_PERCENT_1)));} else {
return and__24299__auto__9;}}
})())) {
return squint_core.first(n.children(G__1647, from, -1));} else {
return G__1647;}}
})(G__1633));
const G__16310 = ((G__1634 == null)) ? (null) : (uppermost_edge_here(from, G__1634));
if ((G__16310 == null)) {
return null;} else {
return n.balanced_range(state, G__16310);}
});
f159.cljs$lang$maxFixedArity = 2;
return f159;
})();
var top_level_node = function (state) {
return squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.identity, squint_core.complement(n.top_QMARK_)), squint_core.iterate(n.up, n.nearest_touching(state, squint_core.get(main_selection(state), "from"), -1))));
};
var modifier_effect = StateEffect.define();
var modifier_field = StateField.define(({ "create": squint_core.constantly(({  })), "update": (function (value, tr) {
const or__24281__auto__1 = (() => {
const G__1652 = squint_core.first(squint_core.filter((function (_PERCENT_1) {
return _PERCENT_1.is(modifier_effect);
}), tr.effects));
if ((G__1652 == null)) {
return null;} else {
return squint_core.get(G__1652, "value");}
})();
if (squint_core.truth_(or__24281__auto__1)) {
return or__24281__auto__1;} else {
return value;}
}) }));
var get_modifier_field = function (state) {
return state.field(modifier_field);
};
var set_modifier_field_BANG_ = function (p__166, value) {
const map__12 = p__166;
const _view3 = map__12;
const dispatch4 = squint_core.get(map__12, "dispatch");
return dispatch4(({ "effects": modifier_effect.of(value), "userEvent": "evalregion" }));
};
var mark = function (spec, {from,to}) {
return Decoration.mark(spec).range(from, to);
};
var single_mark = function (spec, range) {
return Decoration.set([mark(spec, range)]);
};
var mark_spec = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.14);" }) });
var mark_spec_highlight = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.35);" }) });
var cursor_range = function (state) {
if (squint_core.truth_(state.selection.main.empty)) {
return node_at_cursor(state);} else {
return state.selection.main;}
};
var region_field = StateField.define(({ "create": squint_core.constantly(Decoration.none), "update": (function (_value, {state}) {
const map__12 = get_modifier_field(state);
const field3 = map__12;
const Shift4 = squint_core.get(map__12, "Shift");
const Enter5 = squint_core.get(map__12, "Enter");
const modifier6 = squint_core.get(map__12, "modifier");
const modifier_pressed_QMARK_7 = squint_core.get(field3, modifier6);
const spec8 = (squint_core.truth_(Enter5)) ? (mark_spec_highlight) : (mark_spec);
const temp__23951__auto__9 = (squint_core.truth_((() => {
const or__24281__auto__10 = n.embedded_QMARK_(state);
if (squint_core.truth_(or__24281__auto__10)) {
return or__24281__auto__10;} else {
return n.within_program_QMARK_(state);}
})())) ? ((squint_core.truth_((() => {
const and__24299__auto__11 = modifier_pressed_QMARK_7;
if (squint_core.truth_(and__24299__auto__11)) {
return Shift4;} else {
return and__24299__auto__11;}
})())) ? (top_level_node(state)) : ((squint_core.truth_(modifier_pressed_QMARK_7)) ? ((() => {
const or__24281__auto__12 = u.guard(main_selection(state), (function (_PERCENT_1) {
return squint_core.not(squint_core.get(_PERCENT_1, "empty"));
}));
if (squint_core.truth_(or__24281__auto__12)) {
return or__24281__auto__12;} else {
return cursor_range(state);}
})()) : (null))) : (null);
if ((temp__23951__auto__9 == null)) {
return Decoration.none;} else {
const range13 = temp__23951__auto__9;
return single_mark(spec8, range13);}
}) }));
var get_region_field = function (state) {
return state.field(region_field);
};
var current_range = function (state) {
const or__24281__auto__1 = (() => {
const G__1672 = get_region_field(state);
const G__1673 = ((G__1672 == null)) ? (null) : (G__1672.iter());
if ((G__1673 == null)) {
return null;} else {
return u.guard(G__1673, (function (_PERCENT_1) {
return squint_core.get(_PERCENT_1, "value");
}));}
})();
if (squint_core.truth_(or__24281__auto__1)) {
return or__24281__auto__1;} else {
return state.selection.main;}
};
var modifier_extension = function (modifier) {
const handle_enter1 = (function handle_enter (p__168) {
const map__23 = p__168;
const view4 = map__23;
const state5 = squint_core.get(map__23, "state");
set_modifier_field_BANG_(view4, squint_core.assoc(get_modifier_field(state5), "Enter", true));
return null;
});
const handle_key_event6 = (function (p__169, p__170) {
const map__79 = p__169;
const event10 = map__79;
const altKey11 = squint_core.get(map__79, "altKey");
const shiftKey12 = squint_core.get(map__79, "shiftKey");
const metaKey13 = squint_core.get(map__79, "metaKey");
const controlKey14 = squint_core.get(map__79, "controlKey");
const type15 = squint_core.get(map__79, "type");
const map__816 = p__170;
const view17 = map__816;
const state18 = squint_core.get(map__816, "state");
const prev19 = get_modifier_field(state18);
const next20 = (() => {
const G__17121 = ({ "modifier": modifier });
const G__17122 = (squint_core.truth_(altKey11)) ? (squint_core.assoc(G__17121, "Alt", true)) : (G__17121);
const G__17123 = (squint_core.truth_(shiftKey12)) ? (squint_core.assoc(G__17122, "Shift", true)) : (G__17122);
const G__17124 = (squint_core.truth_(metaKey13)) ? (squint_core.assoc(G__17123, "Meta", true)) : (G__17123);
const G__17125 = (squint_core.truth_(controlKey14)) ? (squint_core.assoc(G__17124, "Control", true)) : (G__17124);
if (squint_core.truth_((() => {
const and__24299__auto__26 = ("keydown") === (type15);
if (and__24299__auto__26) {
return ("Enter") === (keyName(event10));} else {
return and__24299__auto__26;}
})())) {
return squint_core.assoc(G__17125, "Enter", true);} else {
return G__17125;}
})();
if ((prev19) !== (next20)) {
set_modifier_field_BANG_(view17, next20)};
return false;
});
const handle_backspace27 = (function (p__172) {
const map__2829 = p__172;
const _view30 = map__2829;
const state31 = squint_core.get(map__2829, "state");
const dispatch32 = squint_core.get(map__2829, "dispatch");
const map__3334 = current_range(state31);
const from35 = squint_core.get(map__3334, "from");
const to36 = squint_core.get(map__3334, "to");
if ((from35) !== (to36)) {
dispatch32(({ "changes": ({ "from": from35, "to": to36, "insert": "" }), "annotations": u.user_event_annotation("delete") }))};
return true;
});
return [modifier_field, keymap.of([({ "key": squint_core.str(modifier, "-Enter"), "shift": handle_enter1, "run": handle_enter1 }), ({ "key": squint_core.str(modifier, "-Backspace"), "run": handle_backspace27, "shift": handle_backspace27 })]), view.EditorView.domEventHandlers(({ "keydown": handle_key_event6, "keyup": handle_key_event6 }))];
};
var extension = function (p__173) {
const map__12 = p__173;
const modifier3 = squint_core.get(map__12, "modifier", "Meta");
return [modifier_extension(modifier3), region_field, EditorView.decorations.from(region_field)];
};
var cursor_node_string = function (state) {
return u.guard((() => {
const G__1741 = node_at_cursor(state);
if ((G__1741 == null)) {
return null;} else {
return u.range_str(state, G__1741);}
})(), squint_core.complement(str.blank_QMARK_));
};
var top_level_string = function (state) {
return u.guard((() => {
const G__1751 = top_level_node(state);
if ((G__1751 == null)) {
return null;} else {
return u.range_str(state, G__1751);}
})(), squint_core.complement(str.blank_QMARK_));
};

export { top_level_node, current_range, set_modifier_field_BANG_, cursor_range, modifier_field, mark_spec_highlight, modifier_extension, extension, node_at_cursor, region_field, get_modifier_field, get_region_field, main_selection, mark_spec, mark, top_level_string, single_mark, uppermost_edge_here, cursor_node_string, modifier_effect }
