import * as squint_core from 'squint-cljs/core.js';
import * as language from '@codemirror/language';
import { IndentContext } from '@codemirror/language';
import { EditorState } from '@codemirror/state';
import * as u from './../util.mjs';
import * as n from './../node.mjs';
var spaces = function (state, n) {
return language.indentString(state, n);
};
var indent_node_props = function (p__180) {
const map__12 = p__180;
const type3 = map__12;
const type_name4 = squint_core.get(map__12, "name");
return function (p__181) {
const map__56 = p__181;
const context7 = map__56;
const node8 = squint_core.get(map__56, "node");
if (("Program") === (type_name4)) {
return 0;} else {
if (squint_core.truth_(n.coll_type_QMARK_(type3))) {
const G__1829 = context7.column(n.end(n.down(node8)));
if (squint_core.truth_((() => {
const and__24299__auto__10 = ("List") === (type_name4);
if (and__24299__auto__10) {
return squint_core.contains_QMARK_(new Set(["Operator", "DefLike", "NS"]), (() => {
const G__18311 = node8;
const G__18312 = ((G__18311 == null)) ? (null) : (n.down(G__18311));
const G__18313 = ((G__18312 == null)) ? (null) : (n.right(G__18312));
if ((G__18313 == null)) {
return null;} else {
return n.name(G__18313);}
})());} else {
return and__24299__auto__10;}
})())) {
return (G__1829) + (1);} else {
return G__1829;}} else {
if ("else") {
return -1;} else {
return null;}}}
};
};
var props = language.indentNodeProp.add(indent_node_props);
var get_indentation = function (context, pos) {
return language.getIndentation(context.state, pos);
};
var make_indent_context = function (state) {
return new IndentContext(state);
};
var indent_all = function (state) {
const context1 = make_indent_context(state);
return u.update_lines(state, (function (from, content) {
const current_indent2 = /^\s*/.exec(content)[0].length;
const indent3 = u.guard(get_indentation(context1, from), squint_core.complement(squint_core.neg_QMARK_));
if (squint_core.truth_(indent3)) {
const G__1844 = squint_core.compare(indent3, current_indent2);
switch (G__1844) {case 0:
return null;
break;
case 1:
return ({ "from": (from) + (current_indent2), "insert": spaces(state, (indent3) - (current_indent2)) });
break;
case -1:
return ({ "from": (from) + (indent3), "to": (from) + (current_indent2) });
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1844))}}
}));
};
var expected_space = function (n1, n2) {
if (squint_core.truth_((() => {
const or__24281__auto__1 = n.start_edge_type_QMARK_(n1);
if (squint_core.truth_(or__24281__auto__1)) {
return or__24281__auto__1;} else {
const or__24281__auto__2 = n.prefix_edge_type_QMARK_(n1);
if (squint_core.truth_(or__24281__auto__2)) {
return or__24281__auto__2;} else {
const or__24281__auto__3 = n.end_edge_type_QMARK_(n2);
if (squint_core.truth_(or__24281__auto__3)) {
return or__24281__auto__3;} else {
return n.same_edge_type_QMARK_(n2);}}}
})())) {
return 0;} else {
return 1;}
};
var space_changes = function (state, from, to) {
const nodes1 = squint_core.reverse(squint_core.filter((function (_PERCENT_1) {
const or__24281__auto__2 = ((from) <= (n.start(_PERCENT_1))) && ((n.start(_PERCENT_1)) <= (to));
if (squint_core.truth_(or__24281__auto__2)) {
return or__24281__auto__2;} else {
return ((from) <= (n.end(_PERCENT_1))) && ((n.end(_PERCENT_1)) <= (to));}
}), n.terminal_nodes(state, from, to)));
const trim_QMARK_3 = (() => {
const G__1854 = squint_core.first(nodes1);
const G__1855 = ((G__1854 == null)) ? (null) : (n.end(G__1854));
if ((G__1855 == null)) {
return null;} else {
return (G__1855) < (to);}
})();
return squint_core.reduce((function (out, p__186) {
const vec__611 = p__186;
const map__912 = squint_core.nth(vec__611, 0, null);
const n213 = squint_core.get(map__912, "type");
const start214 = squint_core.get(map__912, "from");
const map__1015 = squint_core.nth(vec__611, 1, null);
const n116 = squint_core.get(map__1015, "type");
const end117 = squint_core.get(map__1015, "to");
const expected18 = expected_space(n116, n213);
const actual19 = (start214) - (end117);
const G__18720 = squint_core.compare(actual19, expected18);
switch (G__18720) {case 0:
return out;
break;
case 1:
const G__18822 = out;
G__18822.push(({ "from": ((expected18 == 0)) ? (end117) : ((end117 + 1)), "to": start214 }));
return G__18822;
break;
case -1:
const G__18923 = out;
G__18923.push(({ "from": end117, "insert": " " }));
return G__18923;
break;
default:
return out;}
}), (squint_core.truth_(trim_QMARK_3)) ? ([({ "from": n.end(squint_core.first(nodes1)), "to": to })]) : ([]), squint_core.partition(2, 1, nodes1));
};
var into_arr = function (arr, items) {
for (let G__1 of squint_core.iterable(items)) {
const i2 = G__1;
arr.push(i2)
};
return arr;
};
var format_line = function (state, indent_context, from, text, _line_num, changes, format_spaces_QMARK_) {
if (squint_core.truth_(squint_core.some_QMARK_(text))) {
} else {
throw new Error("Assert failed: (some? text)")};
const current_indent1 = /^\s*/.exec(text)[0].length;
const indent2 = u.guard(get_indentation(indent_context, from), squint_core.complement(squint_core.neg_QMARK_));
const indentation_change3 = (squint_core.truth_(indent2)) ? ((() => {
const G__1904 = squint_core.compare(indent2, current_indent1);
switch (G__1904) {case 0:
return null;
break;
case 1:
return ({ "from": (from) + (current_indent1), "insert": spaces(state, (indent2) - (current_indent1)) });
break;
case -1:
return ({ "from": (from) + (indent2), "to": (from) + (current_indent1) });
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1904))}
})()) : (null);
const space_changes6 = (squint_core.truth_((() => {
const and__24299__auto__7 = format_spaces_QMARK_;
if (squint_core.truth_(and__24299__auto__7)) {
const or__24281__auto__8 = n.embedded_QMARK_(state, from);
if (squint_core.truth_(or__24281__auto__8)) {
return or__24281__auto__8;} else {
return n.within_program_QMARK_(state, from);}} else {
return and__24299__auto__7;}
})())) ? (space_changes(state, (from) + (current_indent1), (from) + (squint_core.count(text)))) : (null);
const G__1919 = changes;
const G__19110 = (squint_core.truth_(space_changes6)) ? (into_arr(G__1919, space_changes6)) : (G__1919);
if (squint_core.truth_(indentation_change3)) {
const G__19211 = G__19110;
G__19211.push(indentation_change3);
return G__19211;} else {
return G__19110;}
};
var format_selection = function (state) {
const context1 = make_indent_context(state);
return u.update_selected_lines(state, (function (p__193, changes) {
const map__23 = p__193;
const _line4 = map__23;
const from5 = squint_core.get(map__23, "from");
const text6 = squint_core.get(map__23, "text");
const number7 = squint_core.get(map__23, "number");
return format_line(state, context1, from5, text6, number7, changes, true);
}));
};
var format_all = function (state) {
const context1 = make_indent_context(state);
return u.update_lines(state, (function (from, text, line_num) {
return format_line(state, context1, from, text, line_num, [], true);
}));
};
var format_transaction = function (tr) {
const origin1 = u.get_user_event_annotation(tr);
const temp__23951__auto__2 = (squint_core.truth_(n.within_program_QMARK_(tr.startState))) ? ((() => {
const G__1943 = origin1;
switch (G__1943) {case "input":
return null;
break;
case "input.type":
return null;
break;
case "delete":
return null;
break;
case "keyboardselection":
return null;
break;
case "pointerselection":
return null;
break;
case "select.pointer":
return null;
break;
case "cut":
return null;
break;
case "noformat":
return null;
break;
case "evalregion":
return null;
break;
case "format-selections":
return format_selection(tr.state);
break;
default:
if (squint_core.truth_(tr.changes.empty)) {
return null;} else {
const state5 = tr.state;
const context6 = make_indent_context(state5);
return u.iter_changed_lines(tr, (function (line, changes) {
return format_line(state5, context6, line.from, line.text, line.number, changes, true);
}));}}
})()) : (null);
if ((temp__23951__auto__2 == null)) {
return tr;} else {
const changes7 = temp__23951__auto__2;
return tr.startState.update(squint_core.assoc_BANG_(changes7, "filter", false));}
};
var format = function (state) {
if (squint_core.truth_(u.something_selected_QMARK_(state))) {
return state.update(format_selection(state));} else {
return format_all(state);}
};
var prefix_all = function (prefix, state) {
return u.update_lines(state, (function (from, _, _1) {
return ({ "from": from, "insert": prefix });
}));
};
var ext_format_changed_lines = function () {
return EditorState.transactionFilter.of(format_transaction);
};

export { format_selection, expected_space, get_indentation, ext_format_changed_lines, format_all, format_transaction, space_changes, spaces, make_indent_context, indent_all, props, indent_node_props, prefix_all, into_arr, format_line, format }
