import * as squint_core from 'squint-cljs/core.js';
import { EditorSelection, StateEffect, Transaction } from '@codemirror/state';
import * as sel from './selections.mjs';
var node_js_QMARK_ = squint_core.some_QMARK_(globalThis.process);
var user_event_annotation = function (event_name) {
return Transaction.userEvent.of(event_name);
};
var get_user_event_annotation = function (tr) {
return tr.annotation(Transaction.userEvent);
};
var guard = function (x, f) {
if (squint_core.truth_(f(x))) {
return x;}
};
var from_to = function (p1, p2) {
if ((p1) > (p2)) {
return ({ "from": p2, "to": p1 });} else {
return ({ "from": p1, "to": p2 });}
};
var dispatch_some = function (view, tr) {
if (squint_core.truth_(tr)) {
view.dispatch(tr);
return true;} else {
return false;}
};
var insertion = (() => {
const f278 = (function (var_args) {
const G__2811 = arguments.length;
switch (G__2811) {case 2:
return f278.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
case 3:
return f278.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f278.cljs$core$IFn$_invoke$arity$2 = (function (from, s) {
return insertion(from, from, s);
});
f278.cljs$core$IFn$_invoke$arity$3 = (function (from, to, s) {
return ({ "changes": ({ "insert": s, "from": from, "to": to }), "cursor": (from) + (squint_core.count(s)) });
});
f278.cljs$lang$maxFixedArity = 3;
return f278;
})();
var deletion = (() => {
const f282 = (function (var_args) {
const G__2851 = arguments.length;
switch (G__2851) {case 1:
return f282.cljs$core$IFn$_invoke$arity$1((arguments[0]));
break;
case 2:
return f282.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f282.cljs$core$IFn$_invoke$arity$1 = (function (from) {
return deletion(squint_core.max(0, (from - 1)), from);
});
f282.cljs$core$IFn$_invoke$arity$2 = (function (from, to) {
const from3 = ((from) === (to)) ? (squint_core.max(0, (from - 1))) : (from);
return ({ "cursor": from3, "changes": ({ "from": from3, "to": to }) });
});
f282.cljs$lang$maxFixedArity = 2;
return f282;
})();
var line_content_at = function (state, from) {
return squint_core.get((() => {
const parent__39__auto__1 = squint_core.get_in(state, ["doc"]);
const f__40__auto__2 = squint_core.get(parent__39__auto__1, "lineAt");
return f__40__auto__2.call(parent__39__auto__1, from);
})(), "text");
};
var map_cursor = function (original_range, state, update_map) {
if (squint_core.truth_(squint_core.map_QMARK_(update_map))) {
} else {
throw new Error("Assert failed: (map? update-map)")};
const map__12 = guard(update_map, squint_core.map_QMARK_);
const mapped3 = squint_core.get(map__12, "cursor/mapped");
const cursor4 = squint_core.get(map__12, "cursor");
const from_to5 = squint_core.get(map__12, "from-to");
const range6 = squint_core.get(map__12, "range");
const changes7 = squint_core.get(map__12, "changes");
const change_desc8 = (squint_core.truth_(changes7)) ? (state.changes(changes7)) : (null);
const G__2869 = ({ "range": (() => {
const or__24281__auto__10 = range6;
if (squint_core.truth_(or__24281__auto__10)) {
return or__24281__auto__10;} else {
const or__24281__auto__11 = (squint_core.truth_(mapped3)) ? (sel.cursor(change_desc8.mapPos(mapped3))) : ((squint_core.truth_(cursor4)) ? (sel.cursor(cursor4)) : ((squint_core.truth_(from_to5)) ? (sel.range(from_to5(0), from_to5(1))) : (null)));
if (squint_core.truth_(or__24281__auto__11)) {
return or__24281__auto__11;} else {
return original_range;}}
})() });
if (squint_core.truth_(change_desc8)) {
G__2869.changes = change_desc8;
return G__2869;} else {
return G__2869;}
};
var update_ranges = (() => {
const f287 = (function (var_args) {
const G__2901 = arguments.length;
switch (G__2901) {case 2:
return f287.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
case 3:
return f287.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f287.cljs$core$IFn$_invoke$arity$2 = (function (state, f) {
return update_ranges(state, null, f);
});
f287.cljs$core$IFn$_invoke$arity$3 = (function (state, tr_specs, f) {
return state.update((function (_PERCENT_1) {
return Object.assign(_PERCENT_1, tr_specs);
})(state.changeByRange((function (range) {
const or__24281__auto__3 = (() => {
const temp__24003__auto__4 = f(range);
if ((temp__24003__auto__4 == null)) {
return null;} else {
const result5 = temp__24003__auto__4;
return map_cursor(range, state, result5);}
})();
if (squint_core.truth_(or__24281__auto__3)) {
return or__24281__auto__3;} else {
return ({ "range": range });}
}))));
});
f287.cljs$lang$maxFixedArity = 3;
return f287;
})();
var dispatch_changes = function (state, dispatch, changes) {
if (squint_core.truth_(changes.empty)) {
return null;} else {
return dispatch(state.update(({ "changes": changes })));}
};
var update_lines = (() => {
const f291 = (function (var_args) {
const args2921 = [];
const len__25081__auto__2 = arguments.length;
let i2933 = 0;
while(true){
if ((i2933) < (len__25081__auto__2)) {
args2921.push((arguments[i2933]));
let G__4 = (i2933 + 1);
i2933 = G__4;
continue;
};break;
}
;
const argseq__25399__auto__5 = ((2) < (args2921.length)) ? (args2921.slice(2)) : (null);
return f291.cljs$core$IFn$_invoke$arity$variadic((arguments[0]), (arguments[1]), argseq__25399__auto__5);
});
f291.cljs$core$IFn$_invoke$arity$variadic = (function (state, f, p__297) {
const vec__610 = p__297;
const map__911 = squint_core.nth(vec__610, 0, null);
const from12 = squint_core.get(map__911, "from", 0);
const to13 = squint_core.get(map__911, "to");
const spec14 = squint_core.get(map__911, "spec");
const iterator15 = state.doc.iter();
let result16 = iterator15.next();
let changes17 = [];
let from_pos18 = from12;
let line_num19 = 1;
while(true){
const map__2021 = result16;
const done22 = squint_core.get(map__2021, "done");
const lineBreak23 = squint_core.get(map__2021, "lineBreak");
const value24 = squint_core.get(map__2021, "value");
if (squint_core.truth_((() => {
const or__24281__auto__25 = done22;
if (squint_core.truth_(or__24281__auto__25)) {
return or__24281__auto__25;} else {
return (from12) > (to13);}
})())) {
return state.update(Object.assign(({ "changes": state.changes(changes17) }), spec14));} else {
let G__26 = iterator15.next();
let G__27 = (() => {
const temp__23901__auto__28 = (() => {
const and__24299__auto__29 = squint_core.not(lineBreak23);
if (and__24299__auto__29) {
return f(from_pos18, value24, line_num19);} else {
return and__24299__auto__29;}
})();
if (squint_core.truth_(temp__23901__auto__28)) {
const change30 = temp__23901__auto__28;
const G__29831 = changes17;
G__29831.push(change30);
return G__29831;} else {
return changes17;}
})();
let G__32 = (from_pos18) + (squint_core.count(value24));
let G__33 = (() => {
const G__29934 = line_num19;
if (squint_core.truth_(lineBreak23)) {
return (G__29934 + 1);} else {
return G__29934;}
})();
result16 = G__26;
changes17 = G__27;
from_pos18 = G__32;
line_num19 = G__33;
continue;
};break;
}

});
f291.cljs$lang$maxFixedArity = 2;
f291.cljs$lang$applyTo = (function (seq294) {
const G__29535 = squint_core.first(seq294);
const seq29436 = squint_core.next(seq294);
const G__29637 = squint_core.first(seq29436);
const seq29438 = squint_core.next(seq29436);
const self__25117__auto__39 = this;
return self__25117__auto__39.cljs$core$IFn$_invoke$arity$variadic(G__29535, G__29637, seq29438);
});
return f291;
})();
var update_selected_lines = function (state, f) {
const at_line1 = squint_core.atom(-1);
const doc2 = state.doc;
return state.changeByRange((function (p__300) {
const map__34 = p__300;
const range5 = map__34;
const from6 = squint_core.get(map__34, "from");
const to7 = squint_core.get(map__34, "to");
const anchor8 = squint_core.get(map__34, "anchor");
const head9 = squint_core.get(map__34, "head");
const changes10 = [];
let line11 = doc2.lineAt(from6);
while(true){
const map__1213 = line11;
const line_number14 = squint_core.get(map__1213, "number");
const line_to15 = squint_core.get(map__1213, "to");
if ((line11.number) > (squint_core.deref(at_line1))) {
squint_core.reset_BANG_(at_line1, line_number14);
f(line11, changes10, range5)};
const temp__23901__auto__16 = (() => {
const and__24299__auto__17 = (to7) > (line_to15);
if (and__24299__auto__17) {
return guard(doc2.lineAt((line_to15 + 1)), (function (_PERCENT_1) {
return (_PERCENT_1.number) > (line_number14);
}));} else {
return and__24299__auto__17;}
})();
if (squint_core.truth_(temp__23901__auto__16)) {
const next_line18 = temp__23901__auto__16;
let G__19 = next_line18;
line11 = G__19;
continue;
} else {
const change_set20 = state.changes(changes10);
return ({ "changes": changes10, "range": EditorSelection.range(change_set20.mapPos(anchor8, 1), change_set20.mapPos(head9, 1)) });};break;
}

}));
};
var iter_changed_lines = function (p__301, f) {
const map__13 = p__301;
const tr4 = map__13;
const map__25 = squint_core.get(map__13, "state");
const state6 = map__25;
const doc7 = squint_core.get(map__25, "doc");
const changes8 = squint_core.get(map__13, "changes");
const effects9 = squint_core.get(map__13, "effects");
const selection10 = squint_core.get(map__13, "selection");
const at_line11 = squint_core.atom(-1);
const next_changes12 = [];
const _13 = changes8.iterChanges((function (_from_a, _to_a, from_b, to_b, _inserted) {
const map__1415 = doc7.lineAt(from_b);
const line16 = map__1415;
const line_number17 = squint_core.get(map__1415, "number");
const line_to18 = squint_core.get(map__1415, "to");
let line19 = line16;
while(true){
if ((line_number17) > (squint_core.deref(at_line11))) {
squint_core.reset_BANG_(at_line11, line_number17);
f(line19, next_changes12)};
if ((to_b) <= (line_to18)) {
return null;} else {
const next_line20 = doc7.lineAt((line_to18 + 1));
if (squint_core.truth_((() => {
const and__24299__auto__21 = next_line20;
if (squint_core.truth_(and__24299__auto__21)) {
return (next_line20.number) > (line19.number);} else {
return and__24299__auto__21;}
})())) {
let G__22 = next_line20;
line19 = G__22;
continue;
}};break;
}

}));
const next_changeset23 = state6.changes(next_changes12);
if (squint_core.truth_(squint_core.seq(next_changes12))) {
const G__30224 = squint_core.assoc_BANG_(squint_core.select_keys(tr4, ["annotations", "scrollIntoView", "reconfigure"]), "changes", changes8.compose(next_changeset23));
const G__30225 = (squint_core.truth_(selection10)) ? (squint_core.assoc_BANG_(G__30224, "selection", state6.selection.map(next_changeset23))) : (G__30224);
if (squint_core.truth_(effects9)) {
return squint_core.assoc_BANG_(G__30225, "effects", StateEffect.mapEffects(effects9, next_changeset23));} else {
return G__30225;}} else {
return tr4;}
};
var something_selected_QMARK_ = function (p__303) {
const map__13 = p__303;
const map__24 = squint_core.get(map__13, "selection");
const ranges5 = squint_core.get(map__24, "ranges");
return squint_core.not(squint_core.every_QMARK_((function (_PERCENT_1) {
return _PERCENT_1.empty;
}), ranges5));
};
var range_str = function (state, p__304) {
const map__12 = p__304;
const _selection3 = map__12;
const from4 = squint_core.get(map__12, "from");
const to5 = squint_core.get(map__12, "to");
return squint_core.str((() => {
const parent__39__auto__6 = squint_core.get_in(state, ["doc"]);
const f__40__auto__7 = squint_core.get(parent__39__auto__6, "slice");
return f__40__auto__7.call(parent__39__auto__6, from4, to5);
})());
};

export { dispatch_some, guard, node_js_QMARK_, dispatch_changes, insertion, deletion, line_content_at, update_selected_lines, map_cursor, get_user_event_annotation, user_event_annotation, update_ranges, from_to, iter_changed_lines, update_lines, range_str, something_selected_QMARK_ }
